unit mainunit;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Graphics, FMX.Dialogs,
  FMX.ListView.Types, FMX.ListView.Appearances, FMX.ListView.Adapters.Base,
  Data.Bind.EngExt, Fmx.Bind.DBEngExt, System.Rtti, System.Bindings.Outputs,
  Fmx.Bind.Editors, FireDAC.Stan.Intf, FireDAC.Stan.Option, FireDAC.Stan.Param,
  FireDAC.Stan.Error, FireDAC.DatS, FireDAC.Phys.Intf, FireDAC.DApt.Intf,
  FireDAC.Stan.StorageBin, Data.DB, FireDAC.Comp.DataSet, FireDAC.Comp.Client,
  Data.Bind.Components, Data.Bind.DBScope, FMX.ListView,
  FMX.Controls.Presentation, FMX.StdCtrls, FireDAC.UI.Intf, FireDAC.Stan.Def,
  FireDAC.Stan.Pool, FireDAC.Stan.Async, FireDAC.Phys, FireDAC.Phys.SQLite,
  FireDAC.Phys.SQLiteDef, FireDAC.Stan.ExprFuncs, FireDAC.FMXUI.Wait,
  FireDAC.DApt, FireDAC.Phys.SQLiteVDataSet;

type
  TmainForm = class(TForm)
    btngrp100: TButton;
    ListGroupes: TListView;
    BindingsList1: TBindingsList;
    LinkListGroups: TLinkFillControlToField;
    BindDBparcode: TBindSourceDB;
    fdCustomers: TFDMemTable;
    btnPaysNom: TButton;
    FDConnection1: TFDConnection;
    FDLocalSQL1: TFDLocalSQL;
    FDQuery1: TFDQuery;
    StyleBook1: TStyleBook;
    procedure btngrp100Click(Sender: TObject);
    procedure btnPaysNomClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  mainForm: TmainForm;

implementation

{$R *.fmx}

procedure TmainForm.btngrp100Click(Sender: TObject);
var n : integer;
    aGroup : TFillBreakGroupItem;
    NoMin, NoMax : Integer;
// min et max qu'il faudrait rcuprer via une requte
const min = 1221;
      max = 9841;

begin
LinkListGroups.Active:=false;
LinkListGroups.FillBreakGroups.Clear;
{---}
fdCustomers.DisableControls;
fdCustomers.IndexName:='DEFAULT_ORDER';
FDLocalSQL1.Active:=True;
fdquery1.SQl.text:='SELECT MIN(CUSTNO) AS CMIN,MAX(CUSTNO) AS CMAX FROM fdCustomers';
fdQuery1.Active:=True;
noMin:=fdQuery1.FieldByName('CMin').asInteger div 100;
noMax:=fdQuery1.FieldByName('CMax').asInteger div 100;
FDLocalSQL1.Active:=False;
{--}
//for n := (min div 100) to (max div 100) do
{--}for n := noMin to noMax do{--}
  begin
   aGroup := LinkListGroups.FillBreakGroups.AddItem;
   aGroup.MaxValue:=(n*100+99).ToString;
   aGroup.MinValue:=(n*100).ToString;
   aGroup.DisplayText:=format('Centaine %d',[n*100]);
  end;
LinkListGroups.FillBreakFieldName:='CustNo'; //
LinkListGroups.Active:=True;
fdCustomers.EnableControls;  //
end;

procedure TmainForm.btnPaysNomClick(Sender: TObject);
var aGroup : TFillBreakGroupItem;
begin
fdCustomers.DisableControls;
fdCustomers.IndexName:='PAYS';
FDLocalSQL1.Active:=True;
fdquery1.SQl.text:='SELECT DISTINCT COUNTRY FROM fdCustomers ORDER BY COUNTRY';
fdQuery1.Active:=True;

LinkListGroups.Active:=false;
LinkListGroups.FillBreakGroups.Clear;
while Not FDQuery1.EOF do
  begin
   aGroup := LinkListGroups.FillBreakGroups.AddItem;
   aGroup.MaxValue:=FDQuery1.FieldByName('COUNTRY').asString;
   aGroup.MinValue:=FDQuery1.FieldByName('COUNTRY').asString;
   aGroup.DisplayText:=FDQuery1.FieldByName('COUNTRY').asString;
   FDQuery1.Next;
  end;
FDLocalSQL1.Active:=False;
LinkListGroups.FillBreakFieldName:='Country';
LinkListGroups.Active:=True;
fdCustomers.EnableControls;
end;

procedure TmainForm.FormCreate(Sender: TObject);
begin
FDLocalSQL1.Active:=True;
end;

end.
